# coding: utf-8

"""
    Hangar API

    This page describes the format for the current Hangar REST API as well as general usage guidelines.<br> Note that all routes **not** listed here should be considered **internal**, and can change at a moment's notice. **Do not use them**.  ## Authentication and Authorization There are two ways to consume the API: Authenticated or anonymous.  ### Anonymous When using anonymous authentication, you only have access to public information, but you don't need to worry about creating and storing an API key or handing JWTs.  ### Authenticated If you need access to non-public content or actions, you need to create and use API keys. These can be created by going to the API keys page via the profile dropdown or by going to your user page and clicking on the key icon.  API keys allow you to impersonate yourself, so they should be handled like passwords. **Do not share them with anyone else!**  #### Getting and Using a JWT Once you have an API key, you need to authenticate yourself: Send a `POST` request with your API key identifier to `/api/v1/authenticate?apiKey=yourKey`. The response will contain your JWT as well as an expiration time. Put this JWT into the `Authorization` header of every request and make sure to request a new JWT after the expiration time has passed.  Please also set a meaningful `User-Agent` header. This allows us to better identify loads and needs for potentially new endpoints.  ## Misc ### Date Formats Standard ISO types. Where possible, we use the [OpenAPI format modifier](https://swagger.io/docs/specification/data-models/data-types/#format).  ### Rate Limits and Caching The default rate limit is set at 20 requests every 5 seconds with an initial overdraft for extra leniency. Individual endpoints, such as version creation, may have stricter rate limiting.  If applicable, always cache responses. The Hangar API itself is cached by CloudFlare and internally.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_call, ValidationError
from typing import Dict, List, Optional, Tuple

from pydantic import Field
from typing_extensions import Annotated
from datetime import datetime

from pydantic import StrictBool, StrictStr, field_validator

from typing import Dict, Optional

from hangar_api.models.day_project_stats import DayProjectStats
from hangar_api.models.paginated_result_project import PaginatedResultProject
from hangar_api.models.paginated_result_project_member import PaginatedResultProjectMember
from hangar_api.models.paginated_result_user import PaginatedResultUser
from hangar_api.models.project import Project
from hangar_api.models.request_pagination import RequestPagination

from hangar_api.api_client import ApiClient
from hangar_api.api_response import ApiResponse
from hangar_api.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class ProjectsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_call
    def get_project(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return")], **kwargs) -> Project:  # noqa: E501
        """Returns info on a specific project  # noqa: E501

        Returns info on a specific project. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project(slug, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return (required)
        :type slug: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: Project
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_project_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_project_with_http_info(slug, **kwargs)  # noqa: E501

    @validate_call
    def get_project_with_http_info(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return")], **kwargs) -> ApiResponse:  # noqa: E501
        """Returns info on a specific project  # noqa: E501

        Returns info on a specific project. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project_with_http_info(slug, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return (required)
        :type slug: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(Project, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'slug'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_project" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats: Dict[str, str] = {}

        # process the path parameters
        _path_params: Dict[str, str] = {}
        if _params['slug'] is not None:
            _path_params['slug'] = _params['slug']


        # process the query parameters
        _query_params: List[Tuple[str, str]] = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings: List[str] = ['HangarAuth']  # noqa: E501

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Project",
            '403': "Project",
            '401': "Project",
        }

        return self.api_client.call_api(
            '/api/v1/projects/{slug}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_call
    def get_project_members(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return members for")], pagination : Annotated[RequestPagination, Field(description="Pagination information")], **kwargs) -> PaginatedResultProjectMember:  # noqa: E501
        """Returns the members of a project  # noqa: E501

        Returns the members of a project. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project_members(slug, pagination, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return members for (required)
        :type slug: str
        :param pagination: Pagination information (required)
        :type pagination: RequestPagination
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PaginatedResultProjectMember
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_project_members_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_project_members_with_http_info(slug, pagination, **kwargs)  # noqa: E501

    @validate_call
    def get_project_members_with_http_info(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return members for")], pagination : Annotated[RequestPagination, Field(description="Pagination information")], **kwargs) -> ApiResponse:  # noqa: E501
        """Returns the members of a project  # noqa: E501

        Returns the members of a project. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project_members_with_http_info(slug, pagination, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return members for (required)
        :type slug: str
        :param pagination: Pagination information (required)
        :type pagination: RequestPagination
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PaginatedResultProjectMember, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'slug',
            'pagination'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_project_members" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats: Dict[str, str] = {}

        # process the path parameters
        _path_params: Dict[str, str] = {}
        if _params['slug'] is not None:
            _path_params['slug'] = _params['slug']


        # process the query parameters
        _query_params: List[Tuple[str, str]] = []
        if _params.get('pagination') is not None:  # noqa: E501
            _query_params.append(('pagination', _params['pagination']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings: List[str] = ['HangarAuth']  # noqa: E501

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "PaginatedResultProjectMember",
            '403': "PaginatedResultProjectMember",
            '401': "PaginatedResultProjectMember",
        }

        return self.api_client.call_api(
            '/api/v1/projects/{slug}/members', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_call
    def get_project_stargazers(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return stargazers for")], pagination : Annotated[RequestPagination, Field(description="Pagination information")], **kwargs) -> PaginatedResultUser:  # noqa: E501
        """Returns the stargazers of a project  # noqa: E501

        Returns the stargazers of a project. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project_stargazers(slug, pagination, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return stargazers for (required)
        :type slug: str
        :param pagination: Pagination information (required)
        :type pagination: RequestPagination
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PaginatedResultUser
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_project_stargazers_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_project_stargazers_with_http_info(slug, pagination, **kwargs)  # noqa: E501

    @validate_call
    def get_project_stargazers_with_http_info(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return stargazers for")], pagination : Annotated[RequestPagination, Field(description="Pagination information")], **kwargs) -> ApiResponse:  # noqa: E501
        """Returns the stargazers of a project  # noqa: E501

        Returns the stargazers of a project. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project_stargazers_with_http_info(slug, pagination, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return stargazers for (required)
        :type slug: str
        :param pagination: Pagination information (required)
        :type pagination: RequestPagination
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PaginatedResultUser, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'slug',
            'pagination'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_project_stargazers" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats: Dict[str, str] = {}

        # process the path parameters
        _path_params: Dict[str, str] = {}
        if _params['slug'] is not None:
            _path_params['slug'] = _params['slug']


        # process the query parameters
        _query_params: List[Tuple[str, str]] = []
        if _params.get('pagination') is not None:  # noqa: E501
            _query_params.append(('pagination', _params['pagination']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings: List[str] = ['HangarAuth']  # noqa: E501

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "PaginatedResultUser",
            '403': "PaginatedResultUser",
            '401': "PaginatedResultUser",
        }

        return self.api_client.call_api(
            '/api/v1/projects/{slug}/stargazers', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_call
    def get_project_watchers(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return watchers for")], pagination : Annotated[RequestPagination, Field(description="Pagination information")], **kwargs) -> PaginatedResultUser:  # noqa: E501
        """Returns the watchers of a project  # noqa: E501

        Returns the watchers of a project. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project_watchers(slug, pagination, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return watchers for (required)
        :type slug: str
        :param pagination: Pagination information (required)
        :type pagination: RequestPagination
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PaginatedResultUser
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_project_watchers_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_project_watchers_with_http_info(slug, pagination, **kwargs)  # noqa: E501

    @validate_call
    def get_project_watchers_with_http_info(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return watchers for")], pagination : Annotated[RequestPagination, Field(description="Pagination information")], **kwargs) -> ApiResponse:  # noqa: E501
        """Returns the watchers of a project  # noqa: E501

        Returns the watchers of a project. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project_watchers_with_http_info(slug, pagination, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return watchers for (required)
        :type slug: str
        :param pagination: Pagination information (required)
        :type pagination: RequestPagination
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PaginatedResultUser, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'slug',
            'pagination'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_project_watchers" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats: Dict[str, str] = {}

        # process the path parameters
        _path_params: Dict[str, str] = {}
        if _params['slug'] is not None:
            _path_params['slug'] = _params['slug']


        # process the query parameters
        _query_params: List[Tuple[str, str]] = []
        if _params.get('pagination') is not None:  # noqa: E501
            _query_params.append(('pagination', _params['pagination']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings: List[str] = ['HangarAuth']  # noqa: E501

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "PaginatedResultUser",
            '403': "PaginatedResultUser",
            '401': "PaginatedResultUser",
        }

        return self.api_client.call_api(
            '/api/v1/projects/{slug}/watchers', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_call
    def get_projects(self, pagination : Annotated[RequestPagination, Field(description="Pagination information")], prioritize_exact_match : Annotated[Optional[StrictBool], Field(description="Whether to prioritize the project with an exact name match if present")] = None, sort : Annotated[Optional[StrictStr], Field(description="Used to sort the result")] = None, category : Annotated[Optional[StrictStr], Field(description="A category to filter for")] = None, platform : Annotated[Optional[StrictStr], Field(description="A platform to filter for")] = None, owner : Annotated[Optional[StrictStr], Field(description="The author of the project")] = None, q : Annotated[Optional[StrictStr], Field(description="The query to use when searching")] = None, license : Annotated[Optional[StrictStr], Field(description="A license to filter for")] = None, version : Annotated[Optional[StrictStr], Field(description="A Minecraft version to filter for")] = None, tag : Annotated[Optional[StrictStr], Field(description="A tag to filter for")] = None, **kwargs) -> PaginatedResultProject:  # noqa: E501
        """Searches the projects on Hangar  # noqa: E501

        Searches all the projects on Hangar, or for a single user. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_projects(pagination, prioritize_exact_match, sort, category, platform, owner, q, license, version, tag, async_req=True)
        >>> result = thread.get()

        :param pagination: Pagination information (required)
        :type pagination: RequestPagination
        :param prioritize_exact_match: Whether to prioritize the project with an exact name match if present
        :type prioritize_exact_match: bool
        :param sort: Used to sort the result
        :type sort: str
        :param category: A category to filter for
        :type category: str
        :param platform: A platform to filter for
        :type platform: str
        :param owner: The author of the project
        :type owner: str
        :param q: The query to use when searching
        :type q: str
        :param license: A license to filter for
        :type license: str
        :param version: A Minecraft version to filter for
        :type version: str
        :param tag: A tag to filter for
        :type tag: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PaginatedResultProject
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_projects_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_projects_with_http_info(pagination, prioritize_exact_match, sort, category, platform, owner, q, license, version, tag, **kwargs)  # noqa: E501

    @validate_call
    def get_projects_with_http_info(self, pagination : Annotated[RequestPagination, Field(description="Pagination information")], prioritize_exact_match : Annotated[Optional[StrictBool], Field(description="Whether to prioritize the project with an exact name match if present")] = None, sort : Annotated[Optional[StrictStr], Field(description="Used to sort the result")] = None, category : Annotated[Optional[StrictStr], Field(description="A category to filter for")] = None, platform : Annotated[Optional[StrictStr], Field(description="A platform to filter for")] = None, owner : Annotated[Optional[StrictStr], Field(description="The author of the project")] = None, q : Annotated[Optional[StrictStr], Field(description="The query to use when searching")] = None, license : Annotated[Optional[StrictStr], Field(description="A license to filter for")] = None, version : Annotated[Optional[StrictStr], Field(description="A Minecraft version to filter for")] = None, tag : Annotated[Optional[StrictStr], Field(description="A tag to filter for")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Searches the projects on Hangar  # noqa: E501

        Searches all the projects on Hangar, or for a single user. Requires the `view_public_info` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_projects_with_http_info(pagination, prioritize_exact_match, sort, category, platform, owner, q, license, version, tag, async_req=True)
        >>> result = thread.get()

        :param pagination: Pagination information (required)
        :type pagination: RequestPagination
        :param prioritize_exact_match: Whether to prioritize the project with an exact name match if present
        :type prioritize_exact_match: bool
        :param sort: Used to sort the result
        :type sort: str
        :param category: A category to filter for
        :type category: str
        :param platform: A platform to filter for
        :type platform: str
        :param owner: The author of the project
        :type owner: str
        :param q: The query to use when searching
        :type q: str
        :param license: A license to filter for
        :type license: str
        :param version: A Minecraft version to filter for
        :type version: str
        :param tag: A tag to filter for
        :type tag: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PaginatedResultProject, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'pagination',
            'prioritize_exact_match',
            'sort',
            'category',
            'platform',
            'owner',
            'q',
            'license',
            'version',
            'tag'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_projects" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats: Dict[str, str] = {}

        # process the path parameters
        _path_params: Dict[str, str] = {}

        # process the query parameters
        _query_params: List[Tuple[str, str]] = []
        if _params.get('prioritize_exact_match') is not None:  # noqa: E501
            _query_params.append(('prioritizeExactMatch', _params['prioritize_exact_match']))

        if _params.get('pagination') is not None:  # noqa: E501
            _query_params.append(('pagination', _params['pagination']))

        if _params.get('sort') is not None:  # noqa: E501
            _query_params.append(('sort', _params['sort']))

        if _params.get('category') is not None:  # noqa: E501
            _query_params.append(('category', _params['category']))

        if _params.get('platform') is not None:  # noqa: E501
            _query_params.append(('platform', _params['platform']))

        if _params.get('owner') is not None:  # noqa: E501
            _query_params.append(('owner', _params['owner']))

        if _params.get('q') is not None:  # noqa: E501
            _query_params.append(('q', _params['q']))

        if _params.get('license') is not None:  # noqa: E501
            _query_params.append(('license', _params['license']))

        if _params.get('version') is not None:  # noqa: E501
            _query_params.append(('version', _params['version']))

        if _params.get('tag') is not None:  # noqa: E501
            _query_params.append(('tag', _params['tag']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings: List[str] = ['HangarAuth']  # noqa: E501

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "PaginatedResultProject",
            '403': "PaginatedResultProject",
            '401': "PaginatedResultProject",
        }

        return self.api_client.call_api(
            '/api/v1/projects', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_call
    def show_project_stats(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return stats for")], from_date : Annotated[datetime, Field(description="The first date to include in the result")], to_date : Annotated[datetime, Field(description="The last date to include in the result")], **kwargs) -> Dict[str, DayProjectStats]:  # noqa: E501
        """Returns the stats for a project  # noqa: E501

        Returns the stats (downloads and views) for a project per day for a certain date range. Requires the `is_subject_member` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.show_project_stats(slug, from_date, to_date, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return stats for (required)
        :type slug: str
        :param from_date: The first date to include in the result (required)
        :type from_date: datetime
        :param to_date: The last date to include in the result (required)
        :type to_date: datetime
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: Dict[str, DayProjectStats]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the show_project_stats_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.show_project_stats_with_http_info(slug, from_date, to_date, **kwargs)  # noqa: E501

    @validate_call
    def show_project_stats_with_http_info(self, slug : Annotated[StrictStr, Field(description="The slug of the project to return stats for")], from_date : Annotated[datetime, Field(description="The first date to include in the result")], to_date : Annotated[datetime, Field(description="The last date to include in the result")], **kwargs) -> ApiResponse:  # noqa: E501
        """Returns the stats for a project  # noqa: E501

        Returns the stats (downloads and views) for a project per day for a certain date range. Requires the `is_subject_member` permission.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.show_project_stats_with_http_info(slug, from_date, to_date, async_req=True)
        >>> result = thread.get()

        :param slug: The slug of the project to return stats for (required)
        :type slug: str
        :param from_date: The first date to include in the result (required)
        :type from_date: datetime
        :param to_date: The last date to include in the result (required)
        :type to_date: datetime
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(Dict[str, DayProjectStats], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'slug',
            'from_date',
            'to_date'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method show_project_stats" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats: Dict[str, str] = {}

        # process the path parameters
        _path_params: Dict[str, str] = {}
        if _params['slug'] is not None:
            _path_params['slug'] = _params['slug']


        # process the query parameters
        _query_params: List[Tuple[str, str]] = []
        if _params.get('from_date') is not None:  # noqa: E501
            if isinstance(_params['from_date'], datetime):
                _query_params.append(('fromDate', _params['from_date'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('fromDate', _params['from_date']))

        if _params.get('to_date') is not None:  # noqa: E501
            if isinstance(_params['to_date'], datetime):
                _query_params.append(('toDate', _params['to_date'].strftime(self.api_client.configuration.datetime_format)))
            else:
                _query_params.append(('toDate', _params['to_date']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings: List[str] = ['HangarAuth']  # noqa: E501

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "Dict[str, DayProjectStats]",
            '403': "Dict[str, DayProjectStats]",
            '401': "Dict[str, DayProjectStats]",
        }

        return self.api_client.call_api(
            '/api/v1/projects/{slug}/stats', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
