# coding: utf-8

# flake8: noqa
"""
    Hangar API

    This page describes the format for the current Hangar REST API as well as general usage guidelines.<br> Note that all routes **not** listed here should be considered **internal**, and can change at a moment's notice. **Do not use them**.  ## Authentication and Authorization There are two ways to consume the API: Authenticated or anonymous.  ### Anonymous When using anonymous authentication, you only have access to public information, but you don't need to worry about creating and storing an API key or handing JWTs.  ### Authenticated If you need access to non-public content or actions, you need to create and use API keys. These can be created by going to the API keys page via the profile dropdown or by going to your user page and clicking on the key icon.  API keys allow you to impersonate yourself, so they should be handled like passwords. **Do not share them with anyone else!**  #### Getting and Using a JWT Once you have an API key, you need to authenticate yourself: Send a `POST` request with your API key identifier to `/api/v1/authenticate?apiKey=yourKey`. The response will contain your JWT as well as an expiration time. Put this JWT into the `Authorization` header of every request and make sure to request a new JWT after the expiration time has passed.  Please also set a meaningful `User-Agent` header. This allows us to better identify loads and needs for potentially new endpoints.  ## Misc ### Date Formats Standard ISO types. Where possible, we use the [OpenAPI format modifier](https://swagger.io/docs/specification/data-models/data-types/#format).  ### Rate Limits and Caching The default rate limit is set at 20 requests every 5 seconds with an initial overdraft for extra leniency. Individual endpoints, such as version creation, may have stricter rate limiting.  If applicable, always cache responses. The Hangar API itself is cached by CloudFlare and internally.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from hangar_api.models.api_key import ApiKey
from hangar_api.models.api_session import ApiSession
from hangar_api.models.category import Category
from hangar_api.models.channel_flag import ChannelFlag
from hangar_api.models.color import Color
from hangar_api.models.compact_role import CompactRole
from hangar_api.models.create_api_key_form import CreateAPIKeyForm
from hangar_api.models.day_project_stats import DayProjectStats
from hangar_api.models.file_info import FileInfo
from hangar_api.models.link import Link
from hangar_api.models.link_section import LinkSection
from hangar_api.models.multipart_file_or_url import MultipartFileOrUrl
from hangar_api.models.named_permission import NamedPermission
from hangar_api.models.page_edit_form import PageEditForm
from hangar_api.models.paginated_result_project import PaginatedResultProject
from hangar_api.models.paginated_result_project_compact import PaginatedResultProjectCompact
from hangar_api.models.paginated_result_project_member import PaginatedResultProjectMember
from hangar_api.models.paginated_result_user import PaginatedResultUser
from hangar_api.models.paginated_result_version import PaginatedResultVersion
from hangar_api.models.pagination import Pagination
from hangar_api.models.permission_check import PermissionCheck
from hangar_api.models.permission_type import PermissionType
from hangar_api.models.pinned_status import PinnedStatus
from hangar_api.models.platform import Platform
from hangar_api.models.platform_version_download import PlatformVersionDownload
from hangar_api.models.plugin_dependency import PluginDependency
from hangar_api.models.project import Project
from hangar_api.models.project_channel import ProjectChannel
from hangar_api.models.project_compact import ProjectCompact
from hangar_api.models.project_donation_settings import ProjectDonationSettings
from hangar_api.models.project_license import ProjectLicense
from hangar_api.models.project_member import ProjectMember
from hangar_api.models.project_namespace import ProjectNamespace
from hangar_api.models.project_settings import ProjectSettings
from hangar_api.models.project_sorting_strategy import ProjectSortingStrategy
from hangar_api.models.project_stats import ProjectStats
from hangar_api.models.request_pagination import RequestPagination
from hangar_api.models.review_state import ReviewState
from hangar_api.models.string_content import StringContent
from hangar_api.models.uploaded_version import UploadedVersion
from hangar_api.models.user import User
from hangar_api.models.user_actions import UserActions
from hangar_api.models.user_name_change import UserNameChange
from hangar_api.models.user_permissions import UserPermissions
from hangar_api.models.version import Version
from hangar_api.models.version_stats import VersionStats
from hangar_api.models.version_upload import VersionUpload
from hangar_api.models.visibility import Visibility
